/*
 *  Copyright (C) 2002 Tomasz Kojm <zolw@konarski.edu.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __MATCHER_H
#define __MATCHER_H

#define NUM_CHILDS 256
#define MIN_LENGTH 5

struct patt {
    char *pattern;
    int length;
    char *virname;
    struct patt *next;
};

struct node {
    int islast;
    struct patt *list;
    int maxpatlen;
    struct node *next[NUM_CHILDS], *trans[NUM_CHILDS], *fail;
};

struct nodelist {
    struct node *node;
    struct nodelist *next;
};

void addpatt(struct node *root, struct patt *pattern);
struct nodelist *bfsadd(struct nodelist *bfs, struct node *n);
void failtrans(struct node *root);
void fasttrie(struct node *n, struct node *root);
char *scanbuff(const char *buffer, int length, const struct node *root);
int findpos(const char *buffer, int offset, int length, const struct patt *pattern);
char *scandesc(int desc, const struct node *root);
int checkfile(const char *filename, const struct node *root);
int checkstdin(const struct node *root);

#endif
